Description

This provides Python Console as either a dock widget or a top-level window. It can be switched on the fly - no need to restart QGIS.

This suggests a way for the other dialogs that can be dock widgets or separate windows to be modified similarly. There is no good reason

that I can see not to do it this way, and it is somewhat annoying to have to restart QGIS on a change of window type.

Background:

For a long time the Python Console was a top-level window. Fairly recently it was changed to a dock widget. The way I use the console

necessitates easy navigation (Alt+Tab, for example) using the keyboard. I found it difficult to use the dock widget type using the

keyboard.

I was inclined to make my personal copy of QGIS revert to the top-level window type, but I considered that it is possible to have both

ways, AND to be able to switch without restarting QGIS. In other words, give the user a choice, as this has been implemented at least two

different ways.

The basics to switch from one type to the other:

on change of type - determined by the current state not being the same as the state stored by the Options dialog

    1. 1. re-parent the editor widget by constructing a new window of the other type containing the editor

    2. 2. remove/delete the existing window object that contained the editor

    3. 3. add the new window to the QGIS ui

    4. 4. save the new state

Settings, Options, General tab, "Open Python console in a dock window" check box is the user configuration choice.

Changing Python Console's window type takes effect the next time Plugins, Python Console is chosen, even if the console is visible. As

the editor is retained, nothing done in the console will be lost.

When it is a dock window it is alternately toggled on and off each time the Plugins, Python Console menu item is chosen. (no change from

its behavior when the dock widget type was instituted)

As a top-level window it will be shown each time the Plugins, Python Console menu item is chosen; the window may be minimized or

closed using the buttons on its title bar.

Note that as a dock window an item for it will appear in the main window's context menu and it can be toggled on and off there. It should

probably appear in the View, Panels menu, but I did not do this as it hadn't been done previously.

The contents margins for the editor are to zero to give maximum real estate for the console content. This is especially useful with small

screens.

History

#1 - 2011-06-25 06:48 PM - Steven Mizuno

- File patch_for_4019.txt added
#2 - 2011-10-12 08:10 PM - Alister Hood

- Pull Request or Patch supplied set to Yes

#3 - 2011-11-12 05:52 AM - Tim Sutton

- Target version changed from Version 1.7.1 to Version 1.7.2

#4 - 2011-11-30 12:40 PM - Giovanni Manghi

- Target version changed from Version 1.7.2 to Version 1.7.3

#5 - 2011-12-16 10:54 AM - Giovanni Manghi

- Target version changed from Version 1.7.3 to Version 1.7.4

#6 - 2012-04-15 10:09 AM - Giovanni Manghi

- Target version changed from Version 1.7.4 to Version 2.0.0

#7 - 2012-10-06 02:13 AM - Pirmin Kalberer

- Target version changed from Version 2.0.0 to Future Release - Nice to have

#8 - 2015-12-03 06:30 AM - Médéric RIBREUX

Hello, bug triage...

this is still true in QGIS 2.13,master. Python console is still a QDockWidget and we should be able to have it as a main Window when coding...

#9 - 2017-05-01 12:50 AM - Giovanni Manghi

- Easy fix? set to No

#10 - 2018-01-04 10:13 PM - Borys Jurgiel

- Description updated

- Category changed from Python plugins to PyQGIS Console

Ooops, it seems none of us Python-interested devs ever found this precious patch :(

Would it be possible to prepare a new path against the current Console (or yet better directly a github pull request) and assign it to me, so I can push it

further?

#11 - 2018-01-06 11:13 PM - Steven Mizuno

I will see about creating a new patch or pull request for QGIS3/Qt5.

Files

patch_for_4019.txt 8.02 KB 2011-06-25 Steven Mizuno
